"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.buildHasuraSchema = void 0;
const cross_fetch_1 = require("cross-fetch");
const wrap_1 = require("@graphql-tools/wrap");
const graphql_1 = require("graphql");
function buildHasuraSchema(hasuraUri) {
    return __awaiter(this, void 0, void 0, function* () {
        const executor = ({ document, variables }) => __awaiter(this, void 0, void 0, function* () {
            const query = graphql_1.print(document);
            try {
                const fetchResult = yield cross_fetch_1.fetch(`${hasuraUri}/v1/graphql`, {
                    method: 'POST',
                    headers: {
                        'Content-Type': 'application/json',
                        'X-Hasura-Role': 'cardano-graphql'
                    },
                    body: JSON.stringify({ query, variables })
                });
                return fetchResult.json();
            }
            catch (error) {
                console.error(error);
                throw error;
            }
        });
        return wrap_1.wrapSchema({
            schema: yield wrap_1.introspectSchema(executor),
            executor
        });
    });
}
exports.buildHasuraSchema = buildHasuraSchema;
//# sourceMappingURL=buildHasuraSchema.js.map